<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_CreditCard StructType
 * @subpackage Structs
 */
class JP_CreditCard extends AbstractStructBase
{
    /**
     * The Code
     * Meta information extracted from the WSDL
     * - use: required
     * @var string
     */
    public $Code;
    /**
     * The _
     * @var string
     */
    public $_;
    /**
     * Constructor method for JP_CreditCard
     * @uses JP_CreditCard::setCode()
     * @uses JP_CreditCard::set_()
     * @param string $code
     * @param string $_
     */
    public function __construct($code = null, $_ = null)
    {
        $this
            ->setCode($code)
            ->set_($_);
    }
    /**
     * Get Code value
     * @return string
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @uses \EnumType\JP_CreditCardType::valueIsValid()
     * @uses \EnumType\JP_CreditCardType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $code
     * @return \StructType\JP_CreditCard
     */
    public function setCode($code = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\JP_CreditCardType::valueIsValid($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\JP_CreditCardType', is_array($code) ? implode(', ', $code) : var_export($code, true), implode(', ', \EnumType\JP_CreditCardType::getValidValues())), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get _ value
     * @return string|null
     */
    public function get_()
    {
        return $this->_;
    }
    /**
     * Set _ value
     * @param string $_
     * @return \StructType\JP_CreditCard
     */
    public function set_($_ = null)
    {
        // validation for constraint: string
        if (!is_null($_) && !is_string($_)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($_, true), gettype($_)), __LINE__);
        }
        $this->_ = $_;
        return $this;
    }
}
